*Horizontal tools
*SPSS macros by Kirill Orlov
*kior@comtv.ru
*http://www.spsstools.net/KO-spssmacros.htm
*All rights reserved.

*/*!HRANK*/***************************************************************************************.
define !hrank(vars= !charend('/') /cap= !charend('/') /ties= !charend('/') /order= !charend('/') /missing= !charend('/'))
!if (!upcase(!head(!tail(!vars)))<>'TO') !then
-do if $casenum=1.
- print /'>ERROR. VARS list must be via "to" (adjacent variables).'.
-end if.
-exec.
!else
-count nvars###= !vars (lo thru hi miss).
-string nvars##$ (a5).
-comp nvars##$= ltrim(string(nvars###,f5)).
 !if (!cap=!null) !then !let !cp= 'r' !else !let !cp= !unquote(!cap) !ifend
 !if (!order='D') !then !let !ord='max' !else !let !ord= 'min' !ifend
 !if (!missing<>'INCLUDE') !then !let !rcmiss= ' (miss=sysmis) ' !ifend
 !if (!ties='MEAN' !or !ties=!null) !then !let !add= '#t/2+.5'
 !else !let !f= 'f8'
  !if (!ties='HIGH') !then !let !add= '#t' !else !let !add= 1 !ifend
 !ifend
-do if $casenum=1.
- write outfile= 'temp_hrank_1.sps' /!quote(!conc('recode ',!vars,!rcmiss,' (else=copy) into #1 to #')) nvars##$ '.' /'vector #= #1 to #' nvars##$
                                    /!quote(!conc(' /',!cp)) !if (!cap=!null) !then '=' !quote(!vars) !else '(' nvars##$ !quote(!conc(!f,')')) !ifend '.'.
- write outfile= 'temp_hrank_2.sps' /'loop #j= 1 to ' nvars##$ 'if nvalid(#1 to #' nvars##$ ')>0.' /'comp #m= ' !quote(!conc(!ord,'(#1 to #')) nvars##$ ').'.
-end if.
-exec.
 !if (!cap=!null !and !missing<>'INCLUDE') !then
- recode !vars (miss=sysmis).
 !ifend
-include file= 'temp_hrank_1.sps'.
-comp #rnk= 0.
-comp #b= 0.
-include file= 'temp_hrank_2.sps'.
  !if (!ties<>'GRADE') !then
-  comp #t= 0.
-  loop #i= 1 to nvars###.
-   if #(#i)=#m #t= #t+1.
-  end loop.
-  comp #rnk= #b+!add.
   !if (!ties='CONDENSE') !then
-   comp #b= #rnk.
   !else
-   comp #b= #b+#t.
   !ifend
  !else !let !rnk= 'comp #rnk= #rnk+1'
  !ifend
- loop #i= 1 to nvars###.
-  do if #(#i)=#m.
-   !rnk.
-   comp !cp(#i)= #rnk.
-   comp #(#i)= $sysmis.
-  end if.
- end loop.
-end loop.
-match files /file= * /drop= nvars### nvars##$.
-exec.
 !if (!cap=!null) !then
- miss val !vars ().
 !ifend
-erase file 'temp_hrank_1.sps'.
-erase file 'temp_hrank_2.sps'. 
!ifend
!enddefine.

*/*!HSORT*/***************************************************************************************.
define !hsort(vars= !charend('/') /cap= !charend('/') /cases= !charend('/') /selvar= !charend('/') /order= !charend('/') /missing= !charend('/') /misspos= !charend('/') /redupl= !charend('/'))
!if (!upcase(!head(!tail(!vars)))<>'TO') !then
-do if $casenum=1.
- print /'>ERROR. VARS list must be via "to" (adjacent variables).'.
-end if.
-exec.
!else
 !let !cp= !unquote(!cap)
 !if (!order='D') !then !let !ord='max' !else !let !ord= 'min' !ifend
 !if (!order='R') !then !let !rn= 'rn' !ifend
 !if (!cap=!null) !then !let !v= 's' !else !let !v= 'v' !ifend
 !if (!missing='INCLUDE') !then !let !mfunc= 'sysmis' !else !let !mfunc= 'missing' !let !rcmiss= ' (miss=sysmis) ' !ifend
 !if (!misspos='ORIG' !and !order<>'R') !then !let !doifp= !conc('do if not ',!mfunc,'(',!v,')') !let !endifp= 'end if' !ifend
 !if (!selvar<>!null) !then !let !doifs= 'do if selvar' !let !endifs= 'end if'
  !if (!cap<>!null) !then !let !elses= 'else' !let !comps= 'comp s= value(v)' !ifend
 !ifend
 !if (!cases='FIRST') !then !let !doiff= 'do if $casenum=1' !let !elsef= 'else' !let !endiff= 'end if' !let !compf1= 'comp p= #i' !let !compf2= 'if p>0 s= #(p)'
  !if (!cap=!null) !then !let !compf3= 'if p=0 s= $sysmis' !ifend
 !ifend
 !if (!redupl<>'CROP' !or !order='R') !then !let !brk= 'break' !ifend
 !if (!cases='FIRST' !and !selvar<>!null) !then
- do if $casenum=1 and (!selvar<>1 or missing(!selvar)).
-  print /'>ERROR. CASES=FIRST but the 1st case not equal to 1 in SELVAR variable.'.
- else.
 !ifend
-  count nvars###= !vars (lo thru hi miss).
-  string nvars##$ (a5).
-  comp nvars##$= ltrim(string(nvars###,f5)).
-  do if $casenum=1.
-   write outfile= 'temp_hsort_1.sps' !if (!missing<>'INCLUDE' !and !cases='FIRST') !then !let !rcmiss= '' /'do if $casenum=1.' /'recode ' !quote(!vars) ' (miss=sysmis) (else=copy) into #1 to #' nvars##$ '.' /'else.' !ifend
                                      /!quote(!conc('recode ',!vars,!rcmiss,' (else=copy) into #1 to #')) nvars##$ '.' !if (!missing<>'INCLUDE' !and !cases='FIRST') !then /'end if.' !ifend
                                      /'vector #= #1 to #' nvars##$ !if (!order='R') !then ' /#rn (' nvars##$ ')' !ifend '.'
                                      !if (!cap<>!null) !then /'numer ' !quote(!conc(!cp,1,' to ',!cp)) nvars##$ '.' !ifend
                                      !if (!order='R') !then /'do rep #rn= #rn1 to #rn' nvars##$ '.' /'comp #rn= uniform(1).' /'end rep.' !ifend
                                      /'do rep s= ' !if (!cap=!null) !then !quote(!vars) !else !quote(!conc(!cp,1,' to ',!cp)) nvars##$ ' /v= ' !quote(!vars) !ifend !if (!cases='FIRST') !then ' /p= #p1 to #p' nvars##$ !ifend '.'.
-   write outfile= 'temp_hsort_2.sps' /'comp s= ' !quote(!conc(!ord,'(#',!rn,'1 to #',!rn)) nvars##$ ').' /'loop #i= 1 to ' nvars##$ '.'.
-  end if.
 !if (!cases='FIRST' !and !selvar<>!null) !then
- end if.
 !ifend
- exec.
- set err none.
- include file= 'temp_hsort_1.sps'.
-  !doifs.
-   !doiff.
-    !doifp.
-     include file= 'temp_hsort_2.sps'.
-      set err list.
-      do if !conc(#,!rn)(#i)=value(s).
        !if (!order='R') !then
-        comp s= #(#i).
-        comp #rn(#i)= $sysmis.
        !ifend
-       comp #(#i)= $sysmis.
-       !compf1.
-       !brk.
-      end if.
-     end loop.
-    !endifp.
-   !elsef.
-    !compf2.
-    !compf3.
-   !endiff.
-  !elses.
-   !comps.
-  !endifs.
- end rep.
  !if (!selvar<>!null !and !cap=!null) !then
-  do if missing(!selvar).
-   recode !vars (else=sysmis).
-  end if.
  !ifend
  !if (!cap=!null !and !missing<>'INCLUDE') !then
-  !doifs.
-   !doiff.
-    recode !vars (miss=sysmis).
-   !endiff.
-  !endifs.
  !ifend
- match files /file= * /drop= nvars### nvars##$.
- exec.
  !if (!cap=!null) !then
-  miss val !vars ().
  !ifend
- erase file 'temp_hsort_1.sps'.
- erase file 'temp_hsort_2.sps'. 
!ifend
!enddefine.

*/*!HCOUNT*/***************************************************************************************.
define !hcount(vars= !charend('/') /values= !charend('/') /missing= !charend('/') /rtimes= !charend('/'))
!if (!missing<>'INCLUDE') !then !let !rcmiss= ' (miss=sysmis) ' !ifend
!if (!values=!null) !then !let !vals= 'lo thru hi' !else !let !vals= !values !ifend
!if (!rtimes=!null) !then !let !rt= '>1' !else !let !rt= !rtimes !ifend
count nvars###= !vars (lo thru hi miss).
string nvars##$ (a5).
comp nvars##$= ltrim(string(nvars###,f5)).
do if $casenum=1.
-write outfile= 'temp_hcount_1.sps' /!quote(!conc('recode ',!vars,!rcmiss,' (',!vals,'=copy) (else=sysmis) into #1 to #')) nvars##$ '.'
                                    /'vector #= #1 to #' nvars##$ '.'.
-write outfile= 'temp_hcount_2.sps' /'comp uniq= nvalid(#1 to #' nvars##$ ').'.
end if.
exec.
include file= 'temp_hcount_1.sps'.
comp uniq= 0.
comp uniq_s= 0.
comp uniq_r= 0.
comp #uniq_r= 0.
comp r_max= 0.
comp r_min= nvars###+1.
loop #i= 1 to nvars###-1.
-do if not miss(#(#i)). 
- comp #count= 0.
- loop #j= #i+1 to nvars###.
-  do if #(#j)=#(#i).
-   comp #count= #count+1.
-   comp #(#j)= $sysmis.
-  end if.
- end loop.
- do if #count>0.
-  comp uniq_r= uniq_r+(#count+1 !rt).
-  comp #uniq_r= #uniq_r+(#count+1>1).
-  comp r_max= max(r_max,#count+1).
-  comp r_min= min(r_min,#count+1).
- end if.
-end if.
end loop.
include file= 'temp_hcount_2.sps'.
comp uniq_s= uniq-#uniq_r.
if r_min=nvars###+1 r_min= 0.
match files /file= * /drop= nvars### nvars##$.
exec.
!if (!rtimes<>!null) !then !let !rtt= !conc(' (',!rt,' encounters each)') !ifend
var lab uniq !quote(!conc('Number of encountered unique values ',!values))
        uniq_s !quote(!conc('Number of encountered once unique values ',!values))
        uniq_r !quote(!conc('Number of duplicating',!rtt,' unique values ',!values))
        r_max !quote(!conc('Maximal number of duplicates among values ',!values))
        r_min !quote(!conc('Minimal number of duplicates among values ',!values)).
format uniq uniq_s uniq_r r_max r_min (f8).
erase file 'temp_hcount_1.sps'.
erase file 'temp_hcount_2.sps'.
!enddefine.

*/*!HGAPS*/***************************************************************************************.
define !hgaps(vars= !charend('/') /missing= !charend('/'))
!if (!missing<>'INCLUDE') !then !let !rcmiss= ' (miss=sysmis) ' !ifend
count nvars###= !vars (lo thru hi miss).
string nvars##$ (a5).
comp nvars##$= ltrim(string(nvars###,f5)).
do if $casenum=1.
-write outfile= 'temp_hgaps.sps' /!quote(!conc('recode ',!vars,!rcmiss,' (else=copy) into #1 to #')) nvars##$ '.'
                                 /'vector #= #1 to #' nvars##$ '.'
                                 /'comp #min= min(#1 to #' nvars##$ ').'
                                 /'comp #max= max(#1 to #' nvars##$ ').'.
end if.
exec.
include file= 'temp_hgaps.sps'.
comp mingap= #max-#min.
comp maxgap= 0.
comp #sum= 0.
comp #ss= 0.
comp #n= 0.
loop #i= 1 to nvars###.
-comp #val= #(#i).
-do if not miss(#val).
- comp #uneib= #max.
- comp #lneib= #min.
- loop #j= 1 to nvars###.
-  do if #(#j)>#val.
-   comp #uneib= min(#uneib,#(#j)).
-  else if #(#j)<#val.
-   comp #lneib= max(#lneib,#(#j)).
-  else if #j>#i.
-   comp #(#j)= $sysmis.
-  end if.
- end loop.
- comp maxgap= max(maxgap,#uneib-#val,#val-#lneib).
- comp mingap= min(mingap,#uneib-#val+mingap*(#val=#max),#val-#lneib+mingap*(#val=#min)).
- comp #sum= #sum+#uneib-#lneib.
- comp #ss= #ss+(#uneib-#val)**2+(#val-#lneib)**2.
- comp #n= #n+1.
-end if.
end loop.
comp #n= #n-1.
comp meangap= #sum/2/(#n+(#n=0)).
comp sdgap= sqrt((#ss/2-meangap*#sum+#n*meangap**2)/((#n-1)+(#n=1))).
if maxgap=0 mingap= 0.
match files /file= * /drop= nvars### nvars##$.
exec.
erase file 'temp_hgaps.sps'.
!enddefine.
